Subject: Re: gitk next/prev buttons

From: Jonathan Nieder <[email-masked]>
Date: Tue, 8 Oct 2013 12:36:19 -0700

Hi,

Marc Branchaud wrote:
> On 13-09-30 10:31 PM, Lucas Sandery [three am design] wrote:

>> The "next" and "prev" buttons are lacking consistency and logic. For LTR
>> languages previous is almost always on the left, and next on the right. The
>> words are contradictory, "next" actually goes to backwards chronologically,
>> and "prev" goes forward. Could the positions of the buttons be switched and
>> the text be replaced with "earlier" and "later"? This would make the
>> reference time not just order, and would mean the updated UI would not be
>> confused with the previous one.
>
> I agree with you here (I like "older" and "newer" myself).
>
> In theory gitk accepts the same arguments as "git rev-list", and in theory
> you should be able to use things like --reverse to get the commits in a
> different order.
>
> However, in practice I don't think anyone futzes with the ordering much with
> gitk.  gitk even ignores the --reverse and --timestamp options, and I've had
> a hard time getting gitk to display commits in an order where "older" and
> "newer" would not make sense.

In a branchy history, it is possible for the next matching commit to
actually be newer.  I think the intent of the buttons is "find the
next result, looking down or up in the list of commits in the upper
pane".  Is there some other wording that would convey this better?

>> Also, the arrow-only next/previous buttons (beside the commit ID) should
>> really point up and down. Horizontal directions are ambiguous for navigation
>> of a vertical list.
>
> Here I don't agree.  These arrows are purely about history navigation.  They
> don't have anything to do with "up" or "down" in the list.  In that sense
> they're more like the arrows in your web browser.

True.  It might make sense to make the analogy to a web browser
clearer by using thicker arrows or triangles --- care to mock up icons
to replace the current ones?

The icons are in the gitk source file (search for "bm_left_data") in
xpm format.

Hope that helps,
Jonathan